#ifndef WORKER_HPP
#define WORKER_HPP

class Worker {
public:
  Worker(unsigned size, unsigned long seed);
  ~Worker();
  virtual void Search(mpz_t rop) = 0;
  unsigned Processed();

protected:
  void NextCandidate(mpz_t rop);

  unsigned size_;
  gmp_randstate_t rand_;
  unsigned processed_;
};

#endif // WORKER_HPP
